<?php
$title = 'About - Mathematics Playground';
require_once('header.php');
?>

		<div class="container-fluid">
			<?php require_once('menu.html'); ?>
			<div class="span9">
				<img src='img/mathematics_playground.png' alt='Mathematics Playground' title='Mathematics Playground' />	
				<div class="dropdown clearfix" style='float: right; margin-left: 1em;'>
					<ul class="dropdown-menu" style="display: block; position: static; margin-bottom: 5px; *width: 180px;">
						<li><a href="#acknowledgements">Acknowledgements</a></li>
						<li><a href="#contributing">Contributing</a></li>
						<li><a href="#authors">Authors</a></li>
					</ul>
				</div>
				<div>
					<h2 id='acknowledgements'>Acknowledgements</h2>

					<p>The Mathematics Playground was developed with the assistance of a grant from the <a href='http://www.aber.ac.uk/en/cdsap/funding/ltef/'>Aberystwyth University Learning and Teaching Enhancement Fund</a>.</p>

					<br />

					<h2 id='contributing'>Contributing</h2>

					<p>If you come across any bugs or would like to suggest additional features then please let us know via our <a href='http://github.com/mathematicsplayground/mathematicsplayground/issues'>issue tracker</a>.</p>

					<p>Mathematics Playground is an open source project licensed under the <a href='http://en.wikipedia.org/wiki/MIT_License'>MIT license</a>, if you'd like to contribute improvements to the project then please check out our <a href='http://github.com/mathematicsplayground/mathematicsplayground/'>github page</a>.

					<h3>Future improvements</h3>

					<p>We are particularly interested in expanding the site to include the following topics:</p>

					<h4>Number representation</h4>
					<ul>
						<li>Decimal &amp; binary</li>
						<li>2's complement</li>
						<li>Excess N</li>
						<li>Floating point</li>
						<li>Precision &amp; rounding</li>
					</ul>

					<h4>Polynomials &amp; calculus</h4>
					<ul>
						<li>Graphs</li>
						<li>Differentiation</li>
						<li>Integration</li>
						<li>Stationary points</li>
					</ul>

					<h4>Algebra</h4>
					<ul>
						<li>Rearranging an equation to isolate a variable</li>
					</ul>

					<br />

					<h2 id='authors'>Authors</h2>

					The concept for Mathematics Playground was devised by Amanda Clare and Hannah Dee, who successfully won a grant to develop the idea in to a working system. Michael Sheldon was then hired to design and implement the individual examples for each topic. If you're interested in hiring Michael to work on your own projects, simply visit <a href='http://blog.mikeasoft.com/hire-me/'>his website</a>.

					<h3 style='clear: both; padding-top: 1em;'><a href='http://www.mikeasoft.com'>Michael Sheldon</a></h3>

					<div class='photo'><img src='img/bio/michael-sheldon.jpg' /></div>

					<div class='bio'>Michael holds a BEng in Software Engineering (2008) and a PhD in Developmental Robotics (2012) from Aberystwyth University. He now works as a freelance software developer and researcher, specialising in open source development.

					<h3 style='clear: both; padding-top: 1em;'><a href='http://users.aber.ac.uk/afc/'>Amanda Clare</a></h3>
					
					<div class='photo'><img src='img/bio/afc.jpg' /></div>

					<div class='bio'>Amanda Clare applies computer science to manage data in biology. She also investigates interesting patterns in the biological data using machine learning and data mining algorithms to describe and predict the results of future experiments.</div>

					<br />

					<h3 style='clear: both; padding-top: 1em;'><a href='http://users.aber.ac.uk/hmd1/'>Hannah Dee</a></h3>
					
					<div class='photo'><img src='img/bio/hmd1.jpg' /></div>
					
					<div class='bio'>Hannah has a BSc in Cognitive Science (1996), an MA in Philosophy (1998) and a PhD in Computing (2005) all from the University of Leeds. Her research areas are computer vision for the analysis of human behaviour; the detection of shadows and reasoning about shadows; and student attitudes to the study of computer science. She has held post doctoral positions in Grenoble (France), Leeds, and Kingston upon Thames. She is also a women in computing activist and deputy chair of <a href='http://www.bcs.org/category/8630'>BCSWomen</a>, the British Computer Society's group for women.</div>

					<br />

					<div style='clear: both;'>
					<br /><br /><br />
					</div>

				</div>

			</div>
		</div>
	</body>
</html>
